import java.awt.*;
import java.util.*;

// sample class used to illustrate swapping of data in situ
public class Balloon implements ISame, IChange{
  public CartPt loc;
  public int radius;
  public Color col;
  
  public Balloon(CartPt loc, int radius, Color col){
    this.loc = loc;
    this.radius = radius;
    this.col = col;
  }
  
  // change this radius of this balloon by the given amount
  public void change(int dr){
    this.radius = this.radius + dr;  
  }
  
  // is this balloon the same as the given object?
  public boolean same(Object obj){
    if (obj instanceof Balloon)
      return this.loc.same(((Balloon)obj).loc) &&
             this.radius == ((Balloon)obj).radius &&
             this.col.getRed() == ((Balloon)obj).col.getRed() &&
             this.col.getGreen() == ((Balloon)obj).col.getGreen() &&
             this.col.getBlue() == ((Balloon)obj).col.getBlue();
    else 
      return false;
  } 
  
  // represent the data in this instance as a String
  public String toString(){
    return "new Balloon(loc.x = " + this.loc.x + ", loc.y = " + this.loc.y +
                         ", radius = " + this.radius + ");";
  }
}

// class to represent a location
class CartPt implements ISame{
  public int x;
  public int y;
  
  public CartPt(int x, int y){
    this.x = x;
    this.y = y;
  }
  
  // is this cartesian point the same as the given object?
  public boolean same(Object obj){
    if (obj instanceof CartPt)
      return this.x == ((CartPt)obj).x &&
             this.y == ((CartPt)obj).y;
    else 
      return false;
  }
}

// comparator for balloons: by their radius
class BalloonByRadius implements Comparator{
  
  //compare two balloons by their radius 
  public int compare(Object obj1, Object obj2){
    if ((obj1 instanceof Balloon) &&
        (obj2 instanceof Balloon))
      return ((Balloon)obj1).radius - ((Balloon)obj2).radius;
    else
      throw new ClassCastException("Not a Balloon!");
  }
}