import java.awt.*;
public class Examples {
  // Test harness
  TestHarness th = new TestHarness();
  
  // Balloon data
  Balloon b1 = new Balloon(new CartPt(20, 40), 30, new Color(255, 0, 0));
  Balloon b2 = new Balloon(new CartPt(40, 30), 20, new Color(0, 255, 0));
  Balloon b3 = new Balloon(new CartPt(40, 20), 10, new Color(0, 0, 255));
  Balloon b4 = new Balloon(new CartPt(20, 20), 25, new Color(255, 0, 255));
  
  // ImageFile data
  ImageFile pic1 = new ImageFile("party", 300, 200);
  ImageFile pic2 = new ImageFile("river", 100, 200);
  ImageFile pic3 = new ImageFile("woods", 200, 200);
  
  // TopThree data
  TopThree ttr = 
    new TopThree(this.b1, this.b2, this.b3, new BalloonByRadius());
  
  TopThree ttPicName = 
    new TopThree(this.pic1, this.pic2, this.pic3, new ImageFileByName()); 
  
  public void showData(){
    System.out.println("Balloon b1 = " + this.b1.toString());
    System.out.println("Balloon b2 = " + this.b2.toString());
    System.out.println("Balloon b3 = " + this.b3.toString());
    System.out.println("Balloon b4 = " + this.b4.toString());
    
    System.out.println("ImageFile pic1 = " + this.pic1.toString());
    System.out.println("ImageFile pic2 = " + this.pic2.toString());
    System.out.println("ImageFile pic3 = " + this.pic3.toString());
    
    System.out.println("TopThree ttr = " + this.ttr.toString());
    System.out.println("TopThree ttPicName = " + this.ttPicName.toString());
  }
  // Reset all data
  public void resetData(){
    
    this.b1 = new Balloon(new CartPt(20, 40), 30, new Color(255, 0, 0));
    this.b2 = new Balloon(new CartPt(40, 30), 20, new Color(0, 255, 0));
    this.b3 = new Balloon(new CartPt(40, 20), 10, new Color(0, 0, 255));
    this.b4 = new Balloon(new CartPt(20, 20), 25, new Color(255, 0, 255));
    
    this.pic1 = new ImageFile("party", 300, 200);
    this.pic2 = new ImageFile("river", 100, 200);
    this.pic3 = new ImageFile("woods", 200, 200);
    
    this.ttr = new TopThree(this.b1, this.b2, this.b3, this.ttr.comp);
    
    this.ttPicName = 
      new TopThree(this.pic1, this.pic2, this.pic3, new ImageFileByName());
  }
  
  // Test the method change in the class Balloon
  public void testChangeBalloon(){
    this.resetData();
    this.b4.change(5);
    th.test("change balloon 1: ", this.b4.radius, 30);    
  }
  
  // Test the method change in the class ImageFile
  public void testChangeImageFile(){
    this.resetData();
    this.pic3.change(5);
    th.test("change image file width: ", this.pic3.width, 195);    
    th.test("change image file height: ", this.pic3.height, 195);    
  }
  
  // Test the method change in the class TopThree
  public void testChange(){
    this.resetData();
    this.ttr.change(-10, 5, 20);
    th.test("change balloons 1: ", this.ttr.one, this.b3);    
    th.test("change balloons 2: ", this.ttr.two, this.b2);    
    th.test("change balloons 3: ", this.ttr.three, this.b1);    
  }
  
  public static void main(String[] argv){
    Examples e = new Examples();
    
    e.showData();
    
    e.testChangeBalloon();
    e.testChangeImageFile();
    e.testChange();
    e.th.testReport();
    e.th.fullTestReport();
  }
}