import java.awt.*;
import java.util.*;

// sample class used to illustrate the use of type parameters
public class ImageFile implements ISame, IChange{
  public String name;
  public int width;
  public int height;
  
  public ImageFile(String name, int width, int height){
    this.name = name;
    this.width = width;
    this.height = height;
  }
  
  // crop this image in both directions by the given amount
  public void change(int diff){
    this.width = this.width - diff;  
    this.height = this.height - diff;    
  }
  
  // is this balloon the same as the given object?
  public boolean same(Object obj){
    if (obj instanceof ImageFile)
      return this.name.equals(((ImageFile)obj).name) &&
             this.width == ((ImageFile)obj).width &&
             this.height == ((ImageFile)obj).height;
    else 
      return false;
  } 
  
  // represent the data in this instance as a String
  public String toString(){
    return "new ImageFile(name = " + this.name + ", width = " + this.width +
                         ", height = " + this.height + ");";
  }
}

// comparator for image files: by their name
class ImageFileByName implements Comparator<ImageFile>{
  
  //compare two image files by their name 
  public int compare(ImageFile obj1, ImageFile obj2){
    return obj1.name.compareTo(obj2.name);
  }
}

//comparator for image files: by their size
// class ImageFileBySize ...
