import java.util.*;

// class designed to illustrate the use of type parameters
// data consists of three elements ordered by the given Comparator 
public class TopThree <T extends IChange & ISame> implements ISame{
 
  public T one;
  public T two; 
  public T three;
  public Comparator<T> comp;
  
  // constructor assumes that the three elements are ordered
  public TopThree(T one, T two, T three, Comparator<T> comp){
    this.one = one;
    this.two = two;
    this.three = three;
    this.comp = comp;
    this.reorder();
  }
  
  // change each element by the given amount and re-order the data
  public void change(int d1, int d2, int d3){
    this.one.change(d1);
    this.two.change(d2);
    this.three.change(d3);
    this.reorder();
  }
  
  // reorder the data using the 'resident' Comparator
  public void reorder(){
    // insert the code from the Part 1
  }
   
   
  // is this TopThree same as the given Object?
  public boolean same(Object obj){
    if (obj instanceof TopThree)
      return this.one.same(((TopThree)obj).one) &&
             this.two.same(((TopThree)obj).two) &&
             this.three.same(((TopThree)obj).three) &&
             this.comp.equals(((TopThree)obj).comp);
    else
      throw new ClassCastException(
          "TopThree cannot be compared with " + obj.toString());
  }
  
  // represent the data in this instance as a String
  public String toString(){
    return 
    "new TopThree(\n" +
    "this.numberone = " + this.one.toString() +",\n" +
    "this.numbertwo = " + this.two.toString() +",\n" +
    "this.numberthree = " + this.three.toString() +")\n";
  }
}